import { SerializedSourceFile, SerializedSymbol, SerializedType } from '@code-to-json/core';
import { RefFor } from '@code-to-json/utils';
import { FormattedSourceFileRef, FormattedSymbolRef, FormattedTypeRef, FormatterRefRegistry } from './types';
export interface QueueSink<S, T, SF> {
    handleType(ref: FormattedTypeRef, item: SerializedType): T;
    handleSymbol(ref: FormattedSymbolRef, item: SerializedSymbol): S;
    handleSourceFile(ref: FormattedSourceFileRef, item: SerializedSourceFile): SF;
}
export interface DrainOutput<S, T, SF> {
    symbols: {
        [k: string]: S;
    };
    types: {
        [k: string]: T;
    };
    sourceFiles: {
        [k: string]: SF;
    };
}
interface DataCollectorInputs {
    t: SerializedType;
    s: SerializedSymbol;
    f: SerializedSourceFile;
}
export interface DataCollector {
    queue<K extends keyof DataCollectorInputs & keyof FormatterRefRegistry, E extends DataCollectorInputs[K]>(thing: E, refType: K): RefFor<FormatterRefRegistry, K> | undefined;
    drain<S, T, SF>(sink: Partial<QueueSink<S, T, SF>>): DrainOutput<S, T, SF>;
}
export declare function create(): DataCollector;
export {};
//# sourceMappingURL=data-collector.d.ts.map